(define (prime? n)
  (define (try-it a)
    (cond ((= a 1) #t)
	  ((not (= (expmod a n n) a)) #f)
	  (else (try-it (- a 1)))))
  (try-it (- n 1)))

(define (expmod base exp m)
  (cond ((= exp 0) 1)
	((even? exp)
	 (remainder (square (expmod base (/ exp 2) m))
		    m))
	(else (remainder (* base (expmod base (- exp 1) m))
			 m))))

;; some Carmichael numbers which do pass Fermat's test
(display (prime? 561))
(newline)
(display (prime? 1105))
(newline)
(display (prime? 1729))
(newline)
(display (prime? 2465))
(newline)
(display (prime? 2821))
(newline)
(display (prime? 6601))

